library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity IP_tunel is
	Port 
	( 
		clk				 	: in  STD_LOGIC;
		reset 			 	: in  STD_LOGIC;
		izvorisna_adresa	: in  STD_LOGIC_VECTOR(31 downto 0);
		odredisna_adresa 	: in  STD_LOGIC_VECTOR(31 downto 0);
		kljuc_ulaz_Tx 	 	: in  STD_LOGIC_VECTOR(127 downto 0);
		start_ulaz_Tx 	 	: in  STD_LOGIC;
		kraj_ulaz_Tx 	 	: in  STD_LOGIC;
		ulaz_Tx 		 		: in  STD_LOGIC_VECTOR(127 downto 0);
		start_izlaz_Tx		: out  STD_LOGIC;
		kraj_izlaz_Tx		: out  STD_LOGIC;
		izlaz_Tx 		 	: out  STD_LOGIC_VECTOR(127 downto 0);
                 
		kljuc_ulaz_Rx		: in  STD_LOGIC_VECTOR(127 downto 0);
		start_ulaz_Rx		: in  STD_LOGIC;
		kraj_ulaz_Rx 		: in  STD_LOGIC;
		ulaz_Rx 				: in  STD_LOGIC_VECTOR(127 downto 0);
		start_izlaz_Rx 	: out  STD_LOGIC;
		kraj_izlaz_Rx 	 	: out  STD_LOGIC;
		izlaz_Rx 		 	: out  STD_LOGIC_VECTOR(127 downto 0)
	);
end IP_tunel;

architecture shema of IP_tunel is

component Tx is
	Port	
	(
		clk					: in   STD_LOGIC;
		reset					: in	 STD_LOGIC;
		start_ulaz			: in   STD_LOGIC;
		kraj_ulaz			: in   STD_LOGIC;
		kljuc_ulaz			: in   STD_LOGIC_VECTOR (127 downto 0);
		ulaz					: in   STD_LOGIC_VECTOR (127 downto 0);
		izvorisna_adresa	: in   STD_LOGIC_VECTOR (31 downto 0);
		odredisna_adresa	: in   STD_LOGIC_VECTOR (31 downto 0);
		izlaz					: out  STD_LOGIC_VECTOR (127 downto 0);
		start_izlaz			: out  STD_LOGIC;
		kraj_izlaz			: out  STD_LOGIC
	);
end component;

component Rx is
	Port 
	(
		clk			: in   STD_LOGIC;
		reset			: in	 STD_LOGIC;
		ulaz			: in   STD_LOGIC_VECTOR (127 downto 0);
		kljuc_ulaz	: in   STD_LOGIC_VECTOR (127 downto 0);
		start_ulaz	: in   STD_LOGIC;
		kraj_ulaz	: in   STD_LOGIC;
		izlaz			: out  STD_LOGIC_VECTOR (127 downto 0);
		start_izlaz : out  STD_LOGIC;
		kraj_izlaz  : out  STD_LOGIC
	);
end component;


begin

	Predajnik: Tx  -- povezivanje entiteta Tx sa odgovarajucim signalima iz bloka IP_tunel
	port map
	(
		clk => clk,
		reset => reset,
		start_ulaz => start_ulaz_Tx,
		kraj_ulaz => kraj_ulaz_Tx,
		ulaz => ulaz_Tx,
		kljuc_ulaz => kljuc_ulaz_Tx,
		izvorisna_adresa => izvorisna_adresa,
		odredisna_adresa => odredisna_adresa,
		izlaz => izlaz_Tx,
		start_izlaz => start_izlaz_Tx,
		kraj_izlaz => kraj_izlaz_Tx
	);
	
	Prijemnik: Rx -- povezivanje entiteta Rx sa odgovarajucim signalima iz bloka IP_tunel
	port map
	(
		clk => clk,
		reset => reset,
		start_ulaz => start_ulaz_Rx,
		kraj_ulaz => kraj_ulaz_Rx,
		ulaz => ulaz_Rx,
		kljuc_ulaz => kljuc_ulaz_Rx,
		izlaz => izlaz_Rx,
		start_izlaz => start_izlaz_Rx,
		kraj_izlaz => kraj_izlaz_Rx
	);

end shema;

