library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Rx is
	Port 
	(
		clk			: in   STD_LOGIC;
		reset			: in	 STD_LOGIC;
		ulaz			: in   STD_LOGIC_VECTOR (127 downto 0);
		kljuc_ulaz	: in   STD_LOGIC_VECTOR (127 downto 0);
		start_ulaz	: in   STD_LOGIC;
		kraj_ulaz	: in   STD_LOGIC;
		izlaz			: out  STD_LOGIC_VECTOR (127 downto 0);
		start_izlaz : out  STD_LOGIC;
		kraj_izlaz  : out  STD_LOGIC
	);
end Rx;

architecture shema of Rx is

component AES_128_dekripcija is
	Port 
	( 
		clk		 : in   STD_LOGIC;
		start_in  : in   STD_LOGIC;
		kraj_in   : in   STD_LOGIC;
		data_in   : in   STD_LOGIC_VECTOR (127 downto 0);
		kljuc_in  : in   STD_LOGIC_VECTOR (127 downto 0);
		data_out  : out  STD_LOGIC_VECTOR (127 downto 0);
		start_out : out  STD_LOGIC;
		kraj_out  : out  STD_LOGIC
	);
end component;

component Provera_skidanje_zaglavlja is
	Port 
	( 
		clk		: in   STD_LOGIC;
		reset		: in	 STD_LOGIC;
		start		: in   STD_LOGIC;
		kraj		: in   STD_LOGIC;
		data_in	: in   STD_LOGIC_VECTOR (127 downto 0);
		start_out: out  STD_LOGIC;
		kraj_out : out STD_LOGIC;
		data_out	: out  STD_LOGIC_VECTOR (127 downto 0)
	);
end component;

signal start_out1, kraj_out1 :std_logic:='0';
signal data_out1 :std_logic_vector (127 downto 0):=(others=>'0');

begin

	IP_zaglavlje: Provera_skidanje_zaglavlja
	port map
	(
		clk => clk,
		reset => reset,
		start => start_ulaz,
		kraj => kraj_ulaz,
		data_in => ulaz,
		data_out => data_out1,
		start_out => start_out1,
		kraj_out => kraj_out1
	);
	
	Dekripcija: AES_128_dekripcija
	port map
	(
		clk => clk,
		start_in => start_out1,
		kraj_in => kraj_out1,
		data_in=> data_out1,
		kljuc_in => kljuc_ulaz,
		data_out => izlaz,
		start_out => start_izlaz,
		kraj_out => kraj_izlaz
	);

end shema;

