library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity data_dekripcija is
	Port 
	( 
		clk        : in  STD_LOGIC;
		start      : in  STD_LOGIC;
		kraj       : in  STD_LOGIC;
		data_in	  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc0_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc1_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc2_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc3_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc4_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc5_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc6_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc7_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc8_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc9_in  : in  STD_LOGIC_VECTOR (127 downto 0);
		kljuc10_in : in  STD_LOGIC_VECTOR (127 downto 0);
		start_out  : out STD_LOGIC;
		kraj_out  : out STD_LOGIC;
		data_out   : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end data_dekripcija;

architecture shema of data_dekripcija is

	component runda_Rx is
		port
		(
			data_in:		in  STD_LOGIC_VECTOR (127 downto 0);
			kljuc_in:	in  STD_LOGIC_VECTOR (127 downto 0);
			data_out:	out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;
	component prva_runda_Rx is
		port
		(
			data_in:		in  STD_LOGIC_VECTOR (127 downto 0);
			kljuc_in:	in  STD_LOGIC_VECTOR (127 downto 0);
			data_out:	out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;
	component poslednja_runda_Rx is
		port
		(
			data_in:		in  STD_LOGIC_VECTOR (127 downto 0);
			kljuc_in:	in  STD_LOGIC_VECTOR (127 downto 0);
			data_out:	out  STD_LOGIC_VECTOR (127 downto 0)
		);
	end component;
	-- tip signala za potrebe povezivanja prve_runde_Rx, rudne_Rx i poslednje_rune_Rx
	type niz_registara is array (10 downto 0) of std_logic_vector(127 downto 0);
	signal kljucevi, data_inn, data_outt: niz_registara;
	-- tip signala kojim se vrsi pomeranje starta i kraj radi sinhronizacije sa podatkom 
	type start_kraj is array (0 to 20 ) of std_logic;
	signal startt, krajj : start_kraj;
	--tip signal za pomeranje podataka
	type data is array (1 to 10) of std_logic_vector (127 downto 0);
	signal data_in1 : data;
	-- tipovi signali koji se koristi za potrebe kasnjenja kljuceva
	type kljuc0 is array (1 to 10) of std_logic_vector (127 downto 0);
	signal kljuc0_in1 : kljuc0;
	
	type kljuc1 is array (1 to 9) of std_logic_vector (127 downto 0);
	signal kljuc1_in1 : kljuc1;
	
	type kljuc2 is array (1 to 8) of std_logic_vector (127 downto 0);
	signal kljuc2_in1 : kljuc2;
	
	type kljuc3 is array (1 to 7) of std_logic_vector (127 downto 0);
	signal kljuc3_in1 : kljuc3;
	
	type kljuc4 is array (1 to 6) of std_logic_vector (127 downto 0);
	signal kljuc4_in1 : kljuc4;

	type kljuc5 is array (1 to 5) of std_logic_vector (127 downto 0);
	signal kljuc5_in1 : kljuc5;
	
	type kljuc6 is array (1 to 4) of std_logic_vector (127 downto 0);
	signal kljuc6_in1 : kljuc6;
	
	type kljuc7 is array (1 to 3) of std_logic_vector (127 downto 0);
	signal kljuc7_in1 : kljuc7;
	
	signal kljuc8_in1, kljuc8_in2 : std_logic_vector(127 downto 0);
	signal kljuc9_in1 : std_logic_vector(127 downto 0);
	
begin

	prva_inst: prva_runda_Rx
	port map
	(
			data_in  => data_inn(0),
			kljuc_in => kljucevi(0),
			data_out => data_outt(0)		
	);
	generisi_runde:FOR i IN 1 TO 9 GENERATE
		runda_inst: runda_Rx
		port map
		(
			data_in  => data_inn(i),
			kljuc_in => kljucevi(i),
			data_out => data_outt(i)				
		);
	END GENERATE;
	poslednja_inst: poslednja_runda_Rx
	port map
	(
			data_in  => data_inn(10),
			kljuc_in => kljucevi(10),
			data_out => data_outt(10)		
	);	
	-- proces u kome se vrsi postupak kasnjenja kljuceva
	process(clk, kljuc1_in,kljuc2_in,kljuc3_in,kljuc4_in,kljuc5_in,kljuc6_in,kljuc7_in,kljuc8_in,kljuc9_in)
	begin
		if(clk' event and clk='1') then
		
			kljuc0_in1(1)<=kljuc0_in;
			for i in 2 to 10 loop
				kljuc0_in1(i)<=kljuc0_in1(i-1);
			end loop;
		
			kljuc1_in1(1)<=kljuc1_in;
			for i in 2 to 9 loop
				kljuc1_in1(i)<=kljuc1_in1(i-1);
			end loop;
	
			kljuc2_in1(1)<=kljuc2_in;
			for i in 2 to 8 loop
				kljuc2_in1(i)<=kljuc2_in1(i-1);
			end loop;
	
			kljuc3_in1(1)<=kljuc3_in;
			for i in 2 to 7 loop
				kljuc3_in1(i)<=kljuc3_in1(i-1);
			end loop;
	
			kljuc4_in1(1)<=kljuc4_in;
			for i in 2 to 6 loop
				kljuc4_in1(i)<=kljuc4_in1(i-1);
			end loop;
		
			kljuc5_in1(1)<=kljuc5_in;
			for i in 2 to 5 loop
				kljuc5_in1(i)<=kljuc5_in1(i-1);
			end loop;
	
			kljuc6_in1(1)<=kljuc6_in;
			for i in 2 to 4 loop
				kljuc6_in1(i)<=kljuc6_in1(i-1);
			end loop;
	
			kljuc7_in1(1)<=kljuc7_in;
			for i in 2 to 3 loop
				kljuc7_in1(i)<=kljuc7_in1(i-1);
			end loop;
	
			kljuc8_in1<=kljuc8_in;
			kljuc8_in2<=kljuc8_in1;
		
			kljuc9_in1<=kljuc9_in;
		
		end if;
	end process;
	--dodeljivanja tipu signala kljucevi odgovorajacu kljucevi koji su prethodno zakasnjeni
	kljucevi(0)<=kljuc10_in;
	kljucevi(1)<=kljuc9_in1;
	kljucevi(2)<=kljuc8_in2;
	kljucevi(3)<=kljuc7_in1(3);
	kljucevi(4)<=kljuc6_in1(4);
	kljucevi(5)<=kljuc5_in1(5);
	kljucevi(6)<=kljuc4_in1(6);
	kljucevi(7)<=kljuc3_in1(7);
	kljucevi(8)<=kljuc2_in1(8);
	kljucevi(9)<=kljuc1_in1(9);
	kljucevi(10)<=kljuc0_in1(10);

	
	
	process(clk)
	begin
		if(clk'event and clk='1')then
			-- pomeranje data_in
			data_in1(1)<=data_in;
			for i in 2 to 10 loop
				data_in1(i)<=data_in1(i-1);
			end loop;
			
			data_inn(0)<=data_in1(10);
			for i in 1 to 10 loop
				data_inn(i)<=data_outt(i-1);
			end loop;
			data_out<=data_outt(10);
			--start i kraj sinhronizacija
			startt(0)<=start;
			krajj(0)<=kraj;
			for i in 1 to 20 loop
				startt(i)<=startt(i-1);
				krajj(i)<=krajj(i-1);
			end loop;
			
			start_out<=startt(20);
			kraj_out<=krajj(20);
		end if;
	end process;

end shema;

