
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;

entity inv_mix_kolona is
	Port 
	(
		data_in : in  STD_LOGIC_VECTOR (127 downto 0);
		data_out : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end inv_mix_kolona;

architecture shema of inv_mix_kolona is

procedure inv_mix_kolona2 (variable in_mix_kolona:in STD_LOGIC_VECTOR(31 downto 0);variable out_mix_kolona:out STD_LOGIC_VECTOR(31 downto 0)) IS--ulazni argument je duzine cetiri bajta(jedna kolona)(bajtovi B1,B2,B3 i B4)
		
	variable B1,B2,B3,B4,B1new,B2new,B3new,B4new: STD_LOGIC_VECTOR (7 DOWNTO 0);
	variable x21,x41,x81,x91,xb1,xd1,xe1: STD_LOGIC_VECTOR (7 DOWNTO 0);
	variable x22,x42,x82,x92,xb2,xd2,xe2: STD_LOGIC_VECTOR (7 DOWNTO 0);
	variable x23,x43,x83,x93,xb3,xd3,xe3: STD_LOGIC_VECTOR (7 DOWNTO 0);
	variable x24,x44,x84,x94,xb4,xd4,xe4: STD_LOGIC_VECTOR (7 DOWNTO 0);
	
BEGIN
		
	B1:=in_mix_kolona(31 downto 24);
	B2:=in_mix_kolona(23 downto 16);
	B3:=in_mix_kolona(15 downto 8);
	B4:=in_mix_kolona(7 downto 0);


	--BAJT 1
	if(B1(7)='0')then--racun za 2x
		x21:=B1(6 downto 0)&'0';
	else
		x21:=X"1B" xor B1(6 downto 0)&'0';
	end if;
	
	if(x21(7)='0')then--racun za 4x
		x41:=x21(6 downto 0)&'0';
	else
		x41:=X"1B" xor x21(6 downto 0)&'0';
	end if;
	
	if(x41(7)='0')then--racun za 8x
		x81:=x41(6 downto 0)&'0';
	else
		x81:=X"1B" xor x41(6 downto 0)&'0';
	end if;
	
	x91:=x81 xor B1;--racuna za 9x
	xb1:=x81 xor x21 xor B1;--racuna za 11x
	xd1:=x81 xor x41 xor B1;--racun za 13x
	xe1:=x81 xor x41 xor x21;--racun za 14x	
	
	--BAJT 2
	if(B2(7)='0')then--racun za 2x
		x22:=B2(6 downto 0)&'0';
	else
		x22:=X"1B" xor B2(6 downto 0)&'0';
	end if;
	
	if(x22(7)='0')then--racun za 4x
		x42:=x22(6 downto 0)&'0';
	else
		x42:=X"1B" xor x22(6 downto 0)&'0';
	end if;
	
	if(x42(7)='0')then--racun za 8x
		x82:=x42(6 downto 0)&'0';
	else
		x82:=X"1B" xor x42(6 downto 0)&'0';
	end if;
	
	x92:=x82 xor B2;--racuna za 9x
	xb2:=x82 xor x22 xor B2;--racuna za 11x
	xd2:=x82 xor x42 xor B2;--racun za 13x
	xe2:=x82 xor x42 xor x22;--racun za 14x		


	--BAJT 3
	if(B3(7)='0')then--racun za 2x
		x23:=B3(6 downto 0)&'0';
	else
		x23:=X"1B" xor B3(6 downto 0)&'0';
	end if;
	
	if(x23(7)='0')then--racun za 4x
		x43:=x23(6 downto 0)&'0';
	else
		x43:=X"1B" xor x23(6 downto 0)&'0';
	end if;
	
	if(x43(7)='0')then--racun za 8x
		x83:=x43(6 downto 0)&'0';
	else
		x83:=X"1B" xor x43(6 downto 0)&'0';
	end if;
	
	x93:=x83 xor B3;--racuna za 9x
	xb3:=x83 xor x23 xor B3;--racuna za 11x
	xd3:=x83 xor x43 xor B3;--racun za 13x
	xe3:=x83 xor x43 xor x23;--racun za 14x	


	--BAJT 4
	if(B4(7)='0')then--racun za 2x
		x24:=B4(6 downto 0)&'0';
	else
		x24:=X"1B" xor B4(6 downto 0)&'0';
	end if;
	
	if(x24(7)='0')then--racun za 4x
		x44:=x24(6 downto 0)&'0';
	else
		x44:=X"1B" xor x24(6 downto 0)&'0';
	end if;
	
	if(x44(7)='0')then--racun za 8x
		x84:=x44(6 downto 0)&'0';
	else
		x84:=X"1B" xor x44(6 downto 0)&'0';
	end if;
	
	x94:=x84 xor B4;--racuna za 9x
	xb4:=x84 xor x24 xor B4;--racuna za 11x
	xd4:=x84 xor x44 xor B4;--racun za 13x
	xe4:=x84 xor x44 xor x24;--racun za 14x	
	
	
	B1new:=xe1 xor xb2 xor xd3 xor x94;
	B2new:=x91 xor xe2 xor xb3 xor xd4;
	B3new:=xd1 xor x92 xor xe3 xor xb4;
	B4new:=xb1 xor xd2 xor x93 xor xe4;
	

	out_mix_kolona(31 downto 24):=B1new;
	out_mix_kolona(23 downto 16):=B2new;
	out_mix_kolona(15 downto 8):=B3new;
	out_mix_kolona(7 downto 0):=B4new;
		

END inv_mix_kolona2;

begin

	process(data_in)
		variable data_in2, data_out2 :std_logic_vector (127 downto 0):=(others =>'0');
	begin
		data_in2:=data_in;
		
		inv_mix_kolona2(data_in2(31 downto 0),data_out2(31 downto 0));
		inv_mix_kolona2(data_in2(63 downto 32),data_out2(63 downto 32));
		inv_mix_kolona2(data_in2(95 downto 64),data_out2(95 downto 64));
		inv_mix_kolona2(data_in2(127 downto 96),data_out2(127 downto 96));
			
		data_out<=data_out2;
		
	end process;
end shema;

