library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity poslednja_runda_Tx is
	Port 
	( 
		data_in  : in   STD_LOGIC_VECTOR (127 downto 0);
		kljuc_in : in   STD_LOGIC_VECTOR (127 downto 0);
		data_out : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end poslednja_runda_Tx;

architecture shema of poslednja_runda_Tx is
component sbox is
	Port 
	( 
		in_sbox  : in   STD_LOGIC_VECTOR (127 downto 0);
		out_sbox : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end component;

component shift_rows is
	Port 
	( 
		in_shift_rows  : in   STD_LOGIC_VECTOR (127 downto 0);
		out_shift_rows : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end component;

component add_round_key is
	Port
	(
		data_in  : in   STD_LOGIC_VECTOR (127 downto 0);
		kljuc_in : in   STD_LOGIC_VECTOR (127 downto 0);
		data_out : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end component;

signal data1, data2 :std_logic_vector (127 downto 0);

begin

	sbox_inst: sbox
	port map
	(
		in_sbox =>data_in,
		out_sbox => data1
	);
	
	shift_inst: shift_rows
	port map
	(
		in_shift_rows => data1,
		out_shift_rows => data2
	);
	
	add_key_inst: add_round_key
	port map
	(
		data_in => data2,
		kljuc_in => kljuc_in,
		data_out => data_out
	);
	
end shema;

