library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity sbox is
	Port 
	( 
		in_sbox  : in   STD_LOGIC_VECTOR (127 downto 0);
		out_sbox : out  STD_LOGIC_VECTOR (127 downto 0)
	);
end sbox;

architecture shema of sbox is

procedure sbox2 (signal in_sbox:in STD_LOGIC_VECTOR(7 downto 0);signal out_sbox:out std_logic_vector (7 downto 0)) is

BEGIN
	CASE (in_sbox) IS
		WHEN (x"00") => out_sbox<=x"63" ;
		WHEN (x"01") => out_sbox<=x"7c" ;
		WHEN (x"02") => out_sbox<=x"77" ;
		WHEN (x"03") => out_sbox<=x"7b" ;
		WHEN (x"04") => out_sbox<=x"f2" ;
		WHEN (x"05") => out_sbox<=x"6b" ;
		WHEN (x"06") => out_sbox<=x"6f" ;
		WHEN (x"07") => out_sbox<=x"c5" ;
		WHEN (x"08") => out_sbox<=x"30" ;
		WHEN (x"09") => out_sbox<=x"01" ;
		WHEN (x"0a") => out_sbox<=x"67" ;
		WHEN (x"0b") => out_sbox<=x"2b" ;
		WHEN (x"0c") => out_sbox<=x"fe" ;
		WHEN (x"0d") => out_sbox<=x"d7" ;
		WHEN (x"0e") => out_sbox<=x"ab" ;
		WHEN (x"0f") => out_sbox<=x"76" ;
		WHEN (x"10") => out_sbox<=x"ca" ;
		WHEN (x"11") => out_sbox<=x"82" ;
		WHEN (x"12") => out_sbox<=x"c9" ;
		WHEN (x"13") => out_sbox<=x"7d" ;
		WHEN (x"14") => out_sbox<=x"fa" ;
		WHEN (x"15") => out_sbox<=x"59" ;
		WHEN (x"16") => out_sbox<=x"47" ;
		WHEN (x"17") => out_sbox<=x"f0" ;
		WHEN (x"18") => out_sbox<=x"ad" ;
		WHEN (x"19") => out_sbox<=x"d4" ;
		WHEN (x"1a") => out_sbox<=x"a2" ;
		WHEN (x"1b") => out_sbox<=x"af" ;
		WHEN (x"1c") => out_sbox<=x"9c" ;
		WHEN (x"1d") => out_sbox<=x"a4" ;
		WHEN (x"1e") => out_sbox<=x"72" ;
		WHEN (x"1f") => out_sbox<=x"c0" ;
		WHEN (x"20") => out_sbox<=x"b7" ;
		WHEN (x"21") => out_sbox<=x"fd" ;
		WHEN (x"22") => out_sbox<=x"93" ;
		WHEN (x"23") => out_sbox<=x"26" ;
		WHEN (x"24") => out_sbox<=x"36" ;
		WHEN (x"25") => out_sbox<=x"3f" ;
		WHEN (x"26") => out_sbox<=x"f7" ;
		WHEN (x"27") => out_sbox<=x"cc" ;
		WHEN (x"28") => out_sbox<=x"34" ;
		WHEN (x"29") => out_sbox<=x"a5" ;
		WHEN (x"2a") => out_sbox<=x"e5" ;
		WHEN (x"2b") => out_sbox<=x"f1" ;
		WHEN (x"2c") => out_sbox<=x"71" ;
		WHEN (x"2d") => out_sbox<=x"d8" ;
		WHEN (x"2e") => out_sbox<=x"31" ;
		WHEN (x"2f") => out_sbox<=x"15" ;
		WHEN (x"30") => out_sbox<=x"04" ;
		WHEN (x"31") => out_sbox<=x"c7" ;
		WHEN (x"32") => out_sbox<=x"23" ;
		WHEN (x"33") => out_sbox<=x"c3" ;
		WHEN (x"34") => out_sbox<=x"18" ;
		WHEN (x"35") => out_sbox<=x"96" ;
		WHEN (x"36") => out_sbox<=x"05" ;
		WHEN (x"37") => out_sbox<=x"9a" ;
		WHEN (x"38") => out_sbox<=x"07" ;
		WHEN (x"39") => out_sbox<=x"12" ;
		WHEN (x"3a") => out_sbox<=x"80" ;
		WHEN (x"3b") => out_sbox<=x"e2" ;
		WHEN (x"3c") => out_sbox<=x"eb" ;
		WHEN (x"3d") => out_sbox<=x"27" ;
		WHEN (x"3e") => out_sbox<=x"b2" ;
		WHEN (x"3f") => out_sbox<=x"75" ;
		WHEN (x"40") => out_sbox<=x"09" ;
		WHEN (x"41") => out_sbox<=x"83" ;
		WHEN (x"42") => out_sbox<=x"2c" ;
		WHEN (x"43") => out_sbox<=x"1a" ;
		WHEN (x"44") => out_sbox<=x"1b" ;
		WHEN (x"45") => out_sbox<=x"6e" ;
		WHEN (x"46") => out_sbox<=x"5a" ;
		WHEN (x"47") => out_sbox<=x"a0" ;
		WHEN (x"48") => out_sbox<=x"52" ;
		WHEN (x"49") => out_sbox<=x"3b" ;
		WHEN (x"4a") => out_sbox<=x"d6" ;
		WHEN (x"4b") => out_sbox<=x"b3" ;
		WHEN (x"4c") => out_sbox<=x"29" ;
		WHEN (x"4d") => out_sbox<=x"e3" ;
		WHEN (x"4e") => out_sbox<=x"2f" ;
		WHEN (x"4f") => out_sbox<=x"84" ;
		WHEN (x"50") => out_sbox<=x"53" ;
		WHEN (x"51") => out_sbox<=x"d1" ;
		WHEN (x"52") => out_sbox<=x"00" ;
		WHEN (x"53") => out_sbox<=x"ed" ;
		WHEN (x"54") => out_sbox<=x"20" ;
		WHEN (x"55") => out_sbox<=x"fc" ;
		WHEN (x"56") => out_sbox<=x"b1" ;
		WHEN (x"57") => out_sbox<=x"5b" ;
		WHEN (x"58") => out_sbox<=x"6a" ;
		WHEN (x"59") => out_sbox<=x"cb" ;
		WHEN (x"5a") => out_sbox<=x"be" ;
		WHEN (x"5b") => out_sbox<=x"39" ;
		WHEN (x"5c") => out_sbox<=x"4a" ;
		WHEN (x"5d") => out_sbox<=x"4c" ;
		WHEN (x"5e") => out_sbox<=x"58" ;
		WHEN (x"5f") => out_sbox<=x"cf" ;
		WHEN (x"60") => out_sbox<=x"d0" ;
		WHEN (x"61") => out_sbox<=x"ef" ;
		WHEN (x"62") => out_sbox<=x"aa" ;
		WHEN (x"63") => out_sbox<=x"fb" ;
		WHEN (x"64") => out_sbox<=x"43" ;
		WHEN (x"65") => out_sbox<=x"4d" ;
		WHEN (x"66") => out_sbox<=x"33" ;
		WHEN (x"67") => out_sbox<=x"85" ;
		WHEN (x"68") => out_sbox<=x"45" ;
		WHEN (x"69") => out_sbox<=x"f9" ;
		WHEN (x"6a") => out_sbox<=x"02" ;
		WHEN (x"6b") => out_sbox<=x"7f" ;
		WHEN (x"6c") => out_sbox<=x"50" ;
		WHEN (x"6d") => out_sbox<=x"3c" ;
		WHEN (x"6e") => out_sbox<=x"9f" ;
		WHEN (x"6f") => out_sbox<=x"a8" ;
		WHEN (x"70") => out_sbox<=x"51" ;
		WHEN (x"71") => out_sbox<=x"a3" ;
		WHEN (x"72") => out_sbox<=x"40" ;
		WHEN (x"73") => out_sbox<=x"8f" ;
		WHEN (x"74") => out_sbox<=x"92" ;
		WHEN (x"75") => out_sbox<=x"9d" ;
		WHEN (x"76") => out_sbox<=x"38" ;
		WHEN (x"77") => out_sbox<=x"f5" ;
		WHEN (x"78") => out_sbox<=x"bc" ;
		WHEN (x"79") => out_sbox<=x"b6" ;
		WHEN (x"7a") => out_sbox<=x"da" ;
		WHEN (x"7b") => out_sbox<=x"21" ;
		WHEN (x"7c") => out_sbox<=x"10" ;
		WHEN (x"7d") => out_sbox<=x"ff" ;
		WHEN (x"7e") => out_sbox<=x"f3" ;
		WHEN (x"7f") => out_sbox<=x"d2" ;
		WHEN (x"80") => out_sbox<=x"cd" ;
		WHEN (x"81") => out_sbox<=x"0c" ;
		WHEN (x"82") => out_sbox<=x"13" ;
		WHEN (x"83") => out_sbox<=x"ec" ;
		WHEN (x"84") => out_sbox<=x"5f" ;
		WHEN (x"85") => out_sbox<=x"97" ;
		WHEN (x"86") => out_sbox<=x"44" ;
		WHEN (x"87") => out_sbox<=x"17" ;
		WHEN (x"88") => out_sbox<=x"c4" ;
		WHEN (x"89") => out_sbox<=x"a7" ;
		WHEN (x"8a") => out_sbox<=x"7e" ;
		WHEN (x"8b") => out_sbox<=x"3d" ;
		WHEN (x"8c") => out_sbox<=x"64" ;
		WHEN (x"8d") => out_sbox<=x"5d" ;
		WHEN (x"8e") => out_sbox<=x"19" ;
		WHEN (x"8f") => out_sbox<=x"73" ;
		WHEN (x"90") => out_sbox<=x"60" ;
		WHEN (x"91") => out_sbox<=x"81" ;
		WHEN (x"92") => out_sbox<=x"4f" ;
		WHEN (x"93") => out_sbox<=x"dc" ;
		WHEN (x"94") => out_sbox<=x"22" ;
		WHEN (x"95") => out_sbox<=x"2a" ;
		WHEN (x"96") => out_sbox<=x"90" ;
		WHEN (x"97") => out_sbox<=x"88" ;
		WHEN (x"98") => out_sbox<=x"46" ;
		WHEN (x"99") => out_sbox<=x"ee" ;
		WHEN (x"9a") => out_sbox<=x"b8" ;
		WHEN (x"9b") => out_sbox<=x"14" ;
		WHEN (x"9c") => out_sbox<=x"de" ;
		WHEN (x"9d") => out_sbox<=x"5e" ;
		WHEN (x"9e") => out_sbox<=x"0b" ;
		WHEN (x"9f") => out_sbox<=x"db" ;
		WHEN (x"a0") => out_sbox<=x"e0" ;
		WHEN (x"a1") => out_sbox<=x"32" ;
		WHEN (x"a2") => out_sbox<=x"3a" ;
		WHEN (x"a3") => out_sbox<=x"0a" ;
		WHEN (x"a4") => out_sbox<=x"49" ;
		WHEN (x"a5") => out_sbox<=x"06" ;
		WHEN (x"a6") => out_sbox<=x"24" ;
		WHEN (x"a7") => out_sbox<=x"5c" ;
		WHEN (x"a8") => out_sbox<=x"c2" ;
		WHEN (x"a9") => out_sbox<=x"d3" ;
		WHEN (x"aa") => out_sbox<=x"ac" ;
		WHEN (x"ab") => out_sbox<=x"62" ;
		WHEN (x"ac") => out_sbox<=x"91" ;
		WHEN (x"ad") => out_sbox<=x"95" ;
		WHEN (x"ae") => out_sbox<=x"e4" ;
		WHEN (x"af") => out_sbox<=x"79" ;
		WHEN (x"b0") => out_sbox<=x"e7" ;
		WHEN (x"b1") => out_sbox<=x"c8" ;
		WHEN (x"b2") => out_sbox<=x"37" ;
		WHEN (x"b3") => out_sbox<=x"6d" ;
		WHEN (x"b4") => out_sbox<=x"8d" ;
		WHEN (x"b5") => out_sbox<=x"d5" ;
		WHEN (x"b6") => out_sbox<=x"4e" ;
		WHEN (x"b7") => out_sbox<=x"a9" ;
		WHEN (x"b8") => out_sbox<=x"6c" ;
		WHEN (x"b9") => out_sbox<=x"56" ;
		WHEN (x"ba") => out_sbox<=x"f4" ;
		WHEN (x"bb") => out_sbox<=x"ea" ;
		WHEN (x"bc") => out_sbox<=x"65" ;
		WHEN (x"bd") => out_sbox<=x"7a" ;
		WHEN (x"be") => out_sbox<=x"ae" ;
		WHEN (x"bf") => out_sbox<=x"08" ;
		WHEN (x"c0") => out_sbox<=x"ba" ;
		WHEN (x"c1") => out_sbox<=x"78" ;
		WHEN (x"c2") => out_sbox<=x"25" ;
		WHEN (x"c3") => out_sbox<=x"2e" ;
		WHEN (x"c4") => out_sbox<=x"1c" ;
		WHEN (x"c5") => out_sbox<=x"a6" ;
		WHEN (x"c6") => out_sbox<=x"b4" ;
		WHEN (x"c7") => out_sbox<=x"c6" ;
		WHEN (x"c8") => out_sbox<=x"e8" ;
		WHEN (x"c9") => out_sbox<=x"dd" ;
		WHEN (x"ca") => out_sbox<=x"74" ;
		WHEN (x"cb") => out_sbox<=x"1f" ;
		WHEN (x"cc") => out_sbox<=x"4b" ;
		WHEN (x"cd") => out_sbox<=x"bd" ;
		WHEN (x"ce") => out_sbox<=x"8b" ;
		WHEN (x"cf") => out_sbox<=x"8a" ;
		WHEN (x"d0") => out_sbox<=x"70" ;
		WHEN (x"d1") => out_sbox<=x"3e" ;
		WHEN (x"d2") => out_sbox<=x"b5" ;
		WHEN (x"d3") => out_sbox<=x"66" ;
		WHEN (x"d4") => out_sbox<=x"48" ;
		WHEN (x"d5") => out_sbox<=x"03" ;
		WHEN (x"d6") => out_sbox<=x"f6" ;
		WHEN (x"d7") => out_sbox<=x"0e" ;
		WHEN (x"d8") => out_sbox<=x"61" ;
		WHEN (x"d9") => out_sbox<=x"35" ;
		WHEN (x"da") => out_sbox<=x"57" ;
		WHEN (x"db") => out_sbox<=x"b9" ;
		WHEN (x"dc") => out_sbox<=x"86" ;
		WHEN (x"dd") => out_sbox<=x"c1" ;
		WHEN (x"de") => out_sbox<=x"1d" ;
		WHEN (x"df") => out_sbox<=x"9e" ;
		WHEN (x"e0") => out_sbox<=x"e1" ;
		WHEN (x"e1") => out_sbox<=x"f8" ;
		WHEN (x"e2") => out_sbox<=x"98" ;
		WHEN (x"e3") => out_sbox<=x"11" ;
		WHEN (x"e4") => out_sbox<=x"69" ;
		WHEN (x"e5") => out_sbox<=x"d9" ;
		WHEN (x"e6") => out_sbox<=x"8e" ;
		WHEN (x"e7") => out_sbox<=x"94" ;
		WHEN (x"e8") => out_sbox<=x"9b" ;
		WHEN (x"e9") => out_sbox<=x"1e" ;
		WHEN (x"ea") => out_sbox<=x"87" ;
		WHEN (x"eb") => out_sbox<=x"e9" ;
		WHEN (x"ec") => out_sbox<=x"ce" ;
		WHEN (x"ed") => out_sbox<=x"55" ;
		WHEN (x"ee") => out_sbox<=x"28" ;
		WHEN (x"ef") => out_sbox<=x"df" ;
		WHEN (x"f0") => out_sbox<=x"8c" ;
		WHEN (x"f1") => out_sbox<=x"a1" ;
		WHEN (x"f2") => out_sbox<=x"89" ;
		WHEN (x"f3") => out_sbox<=x"0d" ;
		WHEN (x"f4") => out_sbox<=x"bf" ;
		WHEN (x"f5") => out_sbox<=x"e6" ;
		WHEN (x"f6") => out_sbox<=x"42" ;
		WHEN (x"f7") => out_sbox<=x"68" ;
		WHEN (x"f8") => out_sbox<=x"41" ;
		WHEN (x"f9") => out_sbox<=x"99" ;
		WHEN (x"fa") => out_sbox<=x"2d" ;
		WHEN (x"fb") => out_sbox<=x"0f" ;
		WHEN (x"fc") => out_sbox<=x"b0" ;
		WHEN (x"fd") => out_sbox<=x"54" ;
		WHEN (x"fe") => out_sbox<=x"bb" ;
		WHEN OTHERS => out_sbox<=x"16" ;
	END CASE;
	
		
END sbox2;

begin

	process(in_sbox)
	begin
	
		sbox2(in_sbox(127 downto 120),out_sbox(127 downto 120));
		sbox2(in_sbox(119 downto 112),out_sbox(119 downto 112));
		sbox2(in_sbox(111 downto 104),out_sbox(111 downto 104));
		sbox2(in_sbox(103 downto 96),out_sbox(103 downto 96));
		sbox2(in_sbox(95 downto 88),out_sbox(95 downto 88));
		sbox2(in_sbox(87 downto 80),out_sbox(87 downto 80));
		sbox2(in_sbox(79 downto 72),out_sbox(79 downto 72));
		sbox2(in_sbox(71 downto 64),out_sbox(71 downto 64));
		sbox2(in_sbox(63 downto 56),out_sbox(63 downto 56));
		sbox2(in_sbox(55 downto 48),out_sbox(55 downto 48));
		sbox2(in_sbox(47 downto 40),out_sbox(47 downto 40));
		sbox2(in_sbox(39 downto 32),out_sbox(39 downto 32));
		sbox2(in_sbox(31 downto 24),out_sbox(31 downto 24));
		sbox2(in_sbox(23 downto 16),out_sbox(23 downto 16));
		sbox2(in_sbox(15 downto 8),out_sbox(15 downto 8));
		sbox2(in_sbox(7 downto 0),out_sbox(7 downto 0));

	end process;
	
end shema;

