LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
 
ENTITY test_IP_tunel IS
END test_IP_tunel;
 
ARCHITECTURE behavior OF test_IP_tunel IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT IP_tunel
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
			izvorisna_adresa : IN  std_logic_vector(31 downto 0);
         odredisna_adresa : IN  std_logic_vector(31 downto 0);
			kljuc_ulaz_Tx : IN  std_logic_vector(127 downto 0);
			start_ulaz_Tx : IN  std_logic;
			kraj_ulaz_Tx : IN  std_logic;
         ulaz_Tx : IN  std_logic_vector(127 downto 0);
			start_izlaz_Tx : OUT  std_logic;
			kraj_izlaz_Tx : OUT  std_logic;
			izlaz_Tx : OUT  std_logic_vector(127 downto 0);
                  
         kljuc_ulaz_Rx : IN  std_logic_vector(127 downto 0);
         start_ulaz_Rx : IN  std_logic;
         kraj_ulaz_Rx : IN  std_logic;
         ulaz_Rx : IN  std_logic_vector(127 downto 0);
			start_izlaz_Rx : OUT  std_logic;
         kraj_izlaz_Rx : OUT  std_logic;
         izlaz_Rx : OUT  std_logic_vector(127 downto 0)
        );
    END COMPONENT;
	 

   --Inputs Tx
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
	signal izvorisna_adresa : std_logic_vector(31 downto 0) := (others => '0');
   signal odredisna_adresa : std_logic_vector(31 downto 0) := (others => '0');
	signal kljuc_ulaz_Tx : std_logic_vector(127 downto 0) := (others => '0');
	signal start_ulaz_Tx : std_logic := '0';
	signal kraj_ulaz_Tx : std_logic := '0';
   signal ulaz_Tx : std_logic_vector(127 downto 0) := (others => '0');
	--Outputs Tx
	signal start_izlaz_Tx : std_logic;
	signal kraj_izlaz_Tx : std_logic;
	signal izlaz_Tx : std_logic_vector(127 downto 0);
	--Inputs Rx
	signal kljuc_ulaz_Rx : std_logic_vector(127 downto 0) := (others => '0');
	signal start_ulaz_Rx : std_logic := '0';
   signal kraj_ulaz_Rx : std_logic := '0';
	signal ulaz_Rx : std_logic_vector(127 downto 0) := (others => '0');
   --Outputs Rx
	signal start_izlaz_Rx : std_logic;
	signal kraj_izlaz_Rx : std_logic;
	signal izlaz_Rx : std_logic_vector(127 downto 0);
   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: IP_tunel PORT MAP (
          clk => clk,
          reset => reset,
			 izvorisna_adresa => izvorisna_adresa,
          odredisna_adresa => odredisna_adresa,
			 kljuc_ulaz_Tx => kljuc_ulaz_Tx,
			 start_ulaz_Tx => start_ulaz_Tx,
			 kraj_ulaz_Tx => kraj_ulaz_Tx,
          ulaz_Tx => ulaz_Tx,
			 start_izlaz_Tx => start_izlaz_Tx,
			 kraj_izlaz_Tx => kraj_izlaz_Tx,
			 izlaz_Tx => izlaz_Tx,
         
          kljuc_ulaz_Rx => kljuc_ulaz_Rx,
          start_ulaz_Rx => start_ulaz_Rx,
          kraj_ulaz_Rx => kraj_ulaz_Rx,
          ulaz_Rx => ulaz_Rx,
			 start_izlaz_Rx => start_izlaz_Rx,
          kraj_izlaz_Rx => kraj_izlaz_Rx,
          izlaz_Rx => izlaz_Rx          
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   process
   begin		
     	reset<='1';
		
		wait for 10 ns;
		
		reset<='0';
		
		start_ulaz_Tx<='1';
		kraj_ulaz_Tx<='0';
		izvorisna_adresa<=x"9c2a700b";
		odredisna_adresa<=x"a0f3c1cc";
		kljuc_ulaz_Tx<=x"2b7e151628aed2a6abf7158809cf4f3c";
		ulaz_Tx<=x"cdb9c7ef0fd5757ebdc8052949d1de43";
		
		start_ulaz_Rx<='1';
		kraj_ulaz_Rx<='0';
		kljuc_ulaz_Rx<=x"2b7e151628aed2a6abf7158809cf4f3c";
		ulaz_Rx<=x"450000050000000040110bf39c2a700b";
				
		wait for 10 ns;
		
		start_ulaz_Tx<='0';
		kraj_ulaz_Tx<='0';
		ulaz_Tx<=x"c046cccfb22e5985238cbfecc9e5f5e7";
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"a0f3c1cc3ff000d00000000000000000";
				
		wait for 10 ns;
		
		start_ulaz_Tx<='0';
		kraj_ulaz_Tx<='1';
		ulaz_Tx<=x"9439bd8da20d050f8beccbf35bf8bc71";
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"4c20a3b0995bc66e92a64532f999b158";
		
		wait for 10 ns;
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"019d5d815139140b58cb215a4f724012";
		
		wait for 10 ns;
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='1';
		ulaz_Rx<=x"bd9647abf642c95464bc9c08348a7854";
		
		wait for 10 ns;
		
		-- novi IP datagram
		
		start_ulaz_Tx<='1';
		kraj_ulaz_Tx<='0';
		izvorisna_adresa<=x"a0f3c1cc";
		odredisna_adresa<=x"9c2a700b";
		kljuc_ulaz_Tx<=x"2b7e151628aed2a6abf7158809cf4f3c";
		ulaz_Tx<=x"4b01461c400643e3ef4124e787971bfb";
		
		
		start_ulaz_Rx<='1';
		kraj_ulaz_Rx<='0';
		kljuc_ulaz_Rx<=x"2b7e151628aed2a6abf7158809cf4f3c";
		ulaz_Rx<=x"450000060000000040110bf2a0f3c1cc";
				
		wait for 10 ns;
		
		start_ulaz_Tx<='0';
		kraj_ulaz_Tx<='0';
		ulaz_Tx<=x"f36695e05659286177d58333816edc6a";
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"9c2a700b3ff001cf0000000000000000";
				
		wait for 10 ns;
		
		start_ulaz_Tx<='0';
		kraj_ulaz_Tx<='0';
		ulaz_Tx<=x"74c2fa94ed75c18776778411f02f6aa0";
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"d6ac16e82561c7200a0cc74d10975769";
				
		wait for 10 ns;
		
		start_ulaz_Tx<='0';
		kraj_ulaz_Tx<='1';
		ulaz_Tx<=x"06d5cb74da81144b715b55b2b2265676";
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"e6e79ee1819d729967e7efaccf9ecd45";
		
		wait for 10 ns;
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='0';
		ulaz_Rx<=x"dbd0b885906d848746b596eae6645a54";
		
		wait for 10 ns;
		
		start_ulaz_Rx<='0';
		kraj_ulaz_Rx<='1';
		ulaz_Rx<=x"cadc30b7f79f2f98eaf1b587b3367d6e";
		
		wait for 1000 ns;
   end process;

END;
